# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from marine_sensor_msgs/RadarSector.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import marine_sensor_msgs.msg
import std_msgs.msg

class RadarSector(genpy.Message):
  _md5sum = "df60b1c17b5e9990cfefd1e37ab4e5a8"
  _type = "marine_sensor_msgs/RadarSector"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# A collection of marine radar rays, typically covering a contiguous
# arc of a full circle.

# timestamp in the header is the acquisition time of
# the first ray in the sector.
#
# In frame frame_id, angles are measured around
# the positive Z axis (counterclockwise, if Z is up)
# with zero angle being forward along the X axis
Header header

# start angle of this sector [rad]
float32 angle_start

# angular distance between rays [rad]
float32 angle_increment

# time between rays [seconds] - if your scanner
# is moving, this can be used in interpolating
# position of 3d points
duration time_increment

# time between two consecutive complete scans
# or revolutions [seconds]
# Warning: On hardware that doesn't provide a timestamp,
# time-related fields may be estimated and vary
# from sector to sector as estimates are updated
duration scan_time

# range of the first sample in each ray [m]
float32 range_min

# range of the last sample in each ray [m]
float32 range_max

# intensity data [device-specific units].
RadarEcho[] intensities

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: marine_sensor_msgs/RadarEcho
# This message is a submessage of RadarSector and is not intended
# to be used separately. It represents intensities from a
# single ray.

# Series of intensities from closest to farthest
# along a given angle increment. [device-specific units]
float32[] echoes
"""
  __slots__ = ['header','angle_start','angle_increment','time_increment','scan_time','range_min','range_max','intensities']
  _slot_types = ['std_msgs/Header','float32','float32','duration','duration','float32','float32','marine_sensor_msgs/RadarEcho[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,angle_start,angle_increment,time_increment,scan_time,range_min,range_max,intensities

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadarSector, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.angle_start is None:
        self.angle_start = 0.
      if self.angle_increment is None:
        self.angle_increment = 0.
      if self.time_increment is None:
        self.time_increment = genpy.Duration()
      if self.scan_time is None:
        self.scan_time = genpy.Duration()
      if self.range_min is None:
        self.range_min = 0.
      if self.range_max is None:
        self.range_max = 0.
      if self.intensities is None:
        self.intensities = []
    else:
      self.header = std_msgs.msg.Header()
      self.angle_start = 0.
      self.angle_increment = 0.
      self.time_increment = genpy.Duration()
      self.scan_time = genpy.Duration()
      self.range_min = 0.
      self.range_max = 0.
      self.intensities = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2f4i2f().pack(_x.angle_start, _x.angle_increment, _x.time_increment.secs, _x.time_increment.nsecs, _x.scan_time.secs, _x.scan_time.nsecs, _x.range_min, _x.range_max))
      length = len(self.intensities)
      buff.write(_struct_I.pack(length))
      for val1 in self.intensities:
        length = len(val1.echoes)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.echoes))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.time_increment is None:
        self.time_increment = genpy.Duration()
      if self.scan_time is None:
        self.scan_time = genpy.Duration()
      if self.intensities is None:
        self.intensities = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.angle_start, _x.angle_increment, _x.time_increment.secs, _x.time_increment.nsecs, _x.scan_time.secs, _x.scan_time.nsecs, _x.range_min, _x.range_max,) = _get_struct_2f4i2f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.intensities = []
      for i in range(0, length):
        val1 = marine_sensor_msgs.msg.RadarEcho()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.echoes = s.unpack(str[start:end])
        self.intensities.append(val1)
      self.time_increment.canon()
      self.scan_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2f4i2f().pack(_x.angle_start, _x.angle_increment, _x.time_increment.secs, _x.time_increment.nsecs, _x.scan_time.secs, _x.scan_time.nsecs, _x.range_min, _x.range_max))
      length = len(self.intensities)
      buff.write(_struct_I.pack(length))
      for val1 in self.intensities:
        length = len(val1.echoes)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.echoes.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.time_increment is None:
        self.time_increment = genpy.Duration()
      if self.scan_time is None:
        self.scan_time = genpy.Duration()
      if self.intensities is None:
        self.intensities = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.angle_start, _x.angle_increment, _x.time_increment.secs, _x.time_increment.nsecs, _x.scan_time.secs, _x.scan_time.nsecs, _x.range_min, _x.range_max,) = _get_struct_2f4i2f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.intensities = []
      for i in range(0, length):
        val1 = marine_sensor_msgs.msg.RadarEcho()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.echoes = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.intensities.append(val1)
      self.time_increment.canon()
      self.scan_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f4i2f = None
def _get_struct_2f4i2f():
    global _struct_2f4i2f
    if _struct_2f4i2f is None:
        _struct_2f4i2f = struct.Struct("<2f4i2f")
    return _struct_2f4i2f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
